/**^*********************************************************************
 * This program is a library providing a variation of strings.          *
 * It is free software.                                                 *

 * Copyright 2008  Christopher Olah  (christopherolah.co@gmail.com)     *

 * This program is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU General Public License as       *
 * published by the Free Software Foundation; either version 2 of       *
 * the License, or (at your option) any later version.                  *

 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *

 * You should have received a copy of the GNU General Public License    *
 * along with this program.  If not, see <http://www.gnu.org/licenses/ >.*
 ************************************************************************/

#include <sstream>
#include <string>
#include <iostream>
#include <cstdlib>
#include <math.h>
using namespace std;

class fstring { //flexable string
	fstring package(string input) {
		fstring temp;
		temp.content = input;
		temp.position = 0;
		return temp;
	}
	public:                      //public
	int position;
	string content;
//constructor
	fstring() {
		this->position = 0;
	}
//basic
	void skip() {
		this->position++;
	}
	void clear(){
		this->position = 0;
		this->content = "";
	}
	int length() {
		return content.length();
	}
	bool atend() {
		if (this->position == this->content.length()) {
			return true;
		}else {
			return false;
		}
	}
//Composition Analysis
	bool contains(char input){
		for (int i = 0; i < content.length(); i++){
			if (this->content[i] == input){ return true; }
		}
		return false;
	}
	bool contains_only(char list[]){
		bool is_true = true;
		bool found;
		for (int i = 0; i < this->content.length(); i++) {
			found = false;	
			for (int j = 0; j < strlen(list); j++) {
				if (this->content[i] == list[j]){
					found = true;
				}
			}
			if (found != true) {
				is_true = false;
			}
		}
		return is_true;
	}
//manipulation
	void replace(int location, char replacer) {
		string temp;
		for (int i = 0; i < content.length(); i++) {
			if (i != location) {
				temp += this->content[i];
			}else {
				temp += replacer;
			}
		}
		this->content = temp;
		return;
	}
	void replace(int from, int to, string replacer) {
		string temp;
		for (int i = 0; i < content.length(); i++) {
			if (i != from) {
				temp += this->content[i];
			}else {
				temp += replacer;
				i = to + 1;
			}
		}
		this->content = temp;
		return;
	}
	//converters
	string str() {
		return content;
	}
	double dbl() {
		return atof(this->content.c_str());
	}
	int itg() {
		return atoi(this->content.c_str());
	}
	double rad() {
		return atof(this->content.c_str())/180;
	}
	double deg() {
		return atof(this->content.c_str());
	}
	double base(char symbols[]){
		double value = 0;
		int len = strlen(symbols);
		//what about negative and floating points?
		for (int i = 0; i < this->content.length(); i++) {
			for (int j = 0; j < len; j++) {
				if (content[i] == symbols[j]) {
					value += j*pow(len, i);
				}
			}
		}
		return value;
	}
	double base(fstring symbols){
		if (!symbols.contains('.')){return base_float('.',symbols);}
		double value = 0;
		int len = symbols.length();
		//what about negative and floating points? Negative is dealt with but what about floating points. Also, floating points break the present model... Additionally, there is something wrong here.
		/** @todo: Fix this */
		for (int i = 0; i < content.length(); i++) {
			for (int j = 0; j < len; j++) {
				if (content[i] == symbols[j]) {
					value += j*pow(len,(this->content.length()-i-1));//note: i considers position from the wrongside
					break;
				}
			}
		}
		return value;
	}
	double base_float(char change, fstring symbols){
		double value = 0;
		int len = symbols.length();
		//what about negative and floating points? Negative is dealt with but what about floating points. Also, floating points break the present model... Additionally, there is something wrong here.
		/** @todo: Fix this */
		int old_position = this->position;
		fstring whole = this->get_till('.');
		for (int i = 0; i < whole.length(); i++) {
			for (int j = 0; j < len; j++) {
				if (whole[i] == symbols[j]) {
					value += j*pow(len,(whole.length()-i-1));//note: i considers position from the wrongside
					break;
				}
			}
		}
		fstring part = this->get_rest();
		double f = 0, divider = 1;
		for (int i = 0; i < part.length(); i++) {
			for (int j = 0; j < len; j++) {
				if (part[i] == symbols[j]) {
					f += j*pow(len,(part.length()-i-1));//note: i considers position from the wrongside
					divider *= len;
					break;
				}
			}
		}
		this->position=old_position;
		return value + f/divider;
	}
	void base(char symbols[], double double_input){
		int input = (int) double_input;
		string str;
		int base = strlen(symbols) + 1;
		if (input < 0){
			str += "-";
			input *= -1;
		}
		while (input != 0){
			str = symbols[input % base] + str;
			input -= input % base;
			input /= base;
		}
		this->content = str;
		return;
	}
	double bin() {
		return base("01");
	}
	void bin(double input) {
		return base("01", input);
	}
	double oct() {
		return base("01234567");
	}
	void oct(double input) {
		return base("01234567", input);
	}
	double hex() {
		return base("0123456789ABCDEF");
	}
	void hex(double input) {
		return base("0123456789ABCDEF", input);
	}
//parsing
	fstring get_first(int till){
		fstring temporary;
		for (int i = 0; i < till; i++) {
			temporary += this->content[i];
		}
		return temporary;
	}
	fstring get_from(int begin){
		fstring temporary;
		for (int i = begin; i < this->content.length(); i++) {
			temporary += this->content[i];
		}
		return temporary;
	}
	fstring get_last(int from){
		fstring temporary;
		from = this->content.length() - 1 - from; //we are dealing with the _last_
		for (int i = from; i < this->content.length(); i++) {
			temporary += this->content[i];
		}
		return temporary;
	}
//parsing (position base)
	fstring get_rest(){
		string temp;
		while (  this->position < this->content.length()) {
			temp += this->content[this->position++];
		}
		return package(temp);
	}
	fstring get_till(int end){
		string temp;
		while (  this->position < this->content.length()   &&   this->position < (end + 1)  ) {
			temp += this->content[this->position++];
		}
		return package(temp);
	}
	fstring get_till(string end){
		string temp;
		bool found;
		while (this->position < this->content.length()) {
			found = true;
			for (int i = 0; i < end.length(); i++) {
				if (this->content[this->position + i] != end[i]) {
					found = false;
				}
			}
			if (found) {
				break;
			}else{
				temp += this->content[this->position++];
			}
		}
		return package(temp);		
	}
	fstring get_till(char end) {
		string temp;
		while (this->position < this->content.length()) {
			if (this->content[this->position] != end) {
				temp += this->content[this->position++];
			}else{
				break;
			}
		}
		return package(temp);
	}
	fstring get_in(char open, char close) {
		string temp = "";
		int openness = 0; //How deep 
		while (this->position < this->content.length()) {
			if (this->content[this->position] == open) {
				if (openness != 0) {
					temp += this->content[this->position];
				}
				openness++;
				position++;
			}else if (this->content[this->position] == close) {
				openness--;
				if (openness != 0) {
					temp += this->content[this->position++];
				}
			}else {
				temp += this->content[this->position++];
			}
			if (openness == 0) {
				break;
			}
		}
		return package(temp);
	}
//array-like position
	char operator [] (int input) {
		return content[input];
	}
//       Concatanation
	fstring operator + (string input) {
		fstring returned;
		returned.content = content + input;
		return returned;
	}
	fstring operator + (fstring input) {
		fstring returned;
		returned.content = content + input.content;
		return returned;
	}
	fstring operator + (char input[]) {
		fstring returned;
		stringstream temp;
		temp << content << input;
		returned.content = temp.str();
		return returned;
	}
	fstring operator + (int input) {
		fstring returned;
		stringstream temp;
		temp << content << input;
		returned.content = temp.str();
		return returned;
	}
	fstring operator + (double input) {
		fstring returned;
		stringstream temp;
		temp << content << input;
		returned.content = temp.str();
		return returned;
	}
	void operator = (fstring input) {
		content = input.content;
		position = 0;
	}
	void operator = (string input) {
		content = input;
		position = 0;
	}
	void operator = (char input[]) {
		stringstream temp;
		temp << input;
		content = temp.str();
		return;
	}
	void operator = (int input) {
		stringstream temp;
		temp << input;
		content = temp.str();
		return;
	}
	void operator = (double input) {
		stringstream temp;
		temp << input;
		content = temp.str();
		return;
	}
	void operator += (fstring input) {
		this->content = this->content + input.content;
	}
	void operator += (string input) {
		content = content + input;
	}
	void operator += (char input[]) {
		stringstream temp;
		temp << content << input;
		content = temp.str();
		return;
	}
	void operator += (char input) {
		stringstream temp;
		temp << content << input;
		content = temp.str();
		return;
	}
	void operator += (int input) {
		stringstream temp;
		temp << content << input;
		content = temp.str();
		return;
	}
	void operator += (double input) {
		stringstream temp;
		temp << content << input;
		content = temp.str();
		return;
	}
//comparatives:
	bool operator == (fstring input) {
		return this->content == input.content;
	}
	bool operator == (char input[]) {
		return this->content == input;
	}
	bool operator == (string input) {
		return this->content == input;
	}
	bool operator != (fstring input) {
		return this->content != input.content;
	}
	bool operator != (char input[]) {
		return this->content != input;
	}
	bool operator != (string input) {
		return this->content != input;
	}
};
/*
	ostream ostream::operator << (ostream os, fstring input) {
		os << input.content;
		return os;
	}

	istream istream::operator >> (istream is, fstring input) {
		is >> input.content;
		return is;
	}
*/
