/**
 * This program is a library containing science/math related            *
 * fucntions and variables.                                             *
 * Copyright 2008  Christopher Olah  christopherolah.co@gmail.com       *

 * This program is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU General Public License as       *
 * published by the Free Software Foundation; either version 2 of       *
 * the License, or (at your option) any later version.                  *

 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *

 * You should have received a copy of the GNU General Public License    *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include "fstring.h"
#include <math.h>

/** 
These arrays were created by a parsing program that parsed the KDE 3 Kalzium data.xml file
data.xml contains the following message:

    The data for the isotopes is taken from:
    Lexikon der Physik, 2000 Bertelsmann Lexikon Verlag GmbH
    D. Mende und G. Simon, Physik - Gleichungen und Tabellen, 13. Auflage, 2001 Fachbuchverlag Leipzig

*/
static const double element_mass[111] = {1.00794,4.0026,6.941,9.01218,10.811,12.0107,14.0067,15.9994,18.9984,20.1797,22.9898,24.305,26.9815,28.0855,30.9738,32.065,35.453,39.948,39.0983,40.078,44.9559,47.867,50.9415,51.9961,54.938,55.845,58.9332,58.6934,63.546,65.39,69.723,72.64,74.9216,78.96,79.904,83.8,85.4678,87.62,88.9059,91.224,92.9064,95.94,98.9063,101.07,102.906,106.42,107.868,112.411,114.818,118.71,121.76,127.6,126.904,131.293,132.905,137.237,138.905,140.116,140.908,144.24,146.915,150.36,151.964,157.25,158.925,162.5,164.93,167.259,168.934,173.04,174.967,178.49,180.948,183.84,186.207,190.23,192.217,195.078,196.967,200.59,204.383,207.2,208.98,208.982,209.987,222.018,223.02,226.025,227.028,232.038,231.036,238.029,237.048,244.064,243.061,247.07,247.07,251.08,252.083,257.095,258.099,259.101,262.11,261.109,262.114,263.119,262.123,265.131,266.138,271,272};
static const string element_name[111] = {"Hydrogen","Helium","Lithium","Beryllium","Boron","Carbon","Nitrogen","Oxygen","Fluorine","Neon","Sodium","Magnesium","Aluminum","Silicon","Phosphorus","Sulfur","Chlorine","Argon","Potassium","Calcium","Scandium","Titanium","Vanadium","Chromium","Manganese","Iron","Cobalt","Nickel","Copper","Zinc","Gallium","Germanium","Arsenic","Selenium","Bromine","Krypton","Rubidium","Strontium","Yttrium","Zirconium","Niobium","Molybdenum","Technetium","Ruthenium","Rhodium","Palladium","Silver","Cadmium","Indium","Tin","Antimony","Tellurium","Iodine","Xenon","Caesium","Barium","Lanthanum","Cerium","Praseodymium","Neodymium","Promethium","Samarium","Europium","Gadolinium","Terbium","Dysprosium","Holmium","Erbium","Thulium","Ytterbium","Lutetium","Hafnium","Tantalum","Tungsten","Rhenium","Osmium","Iridium","Platinum","Gold","Mercury","Thallium","Lead","Bismuth","Polonium","Astatine","Radon","Francium","Radium","Actinium","Thorium","Protactinium","Uranium","Neptunium","Plutonium","Americium","Curium","Berkelium","Californium","Einsteinium","Fermium","Mendelevium","Nobelium","Lawrencium","Rutherfordium","Dubnium","Seaborgium","Bohrium","Hassium","Meitnerium","Darmstadtium","Roentgenium"};
static const string element_symbol[111] = {"H","He","Li","Be","B","C","N","O","F","Ne","Na","Mg","Al","Si","P","S","Cl","Ar","K","Ca","Sc","Ti","V","Cr","Mn","Fe","Co","Ni","Cu","Zn","Ga","Ge","As","Se","Br","Kr","Rb","Sr","Y","Zr","Nb","Mo","Tc","Ru","Rh","Pd","Ag","Cd","In","Sn","Sb","Te","I","Xe","Cs","Ba","La","Ce","Pr","Nd","Pm","Sm","Eu","Gd","Tb","Dy","Ho","Er","Tm","Yb","Lu","Hf","Ta","W","Re","Os","Ir","Pt","Au","Hg","Tl","Pb","Bi","Po","At","Rn","Fr","Ra","Ac","Th","Pa","U","Np","Pu","Am","Cm","Bk","Cf","Es","Fm","Md","No","Lr","Rf","Db","Sg","Bh","Hs","Mt","Ds","Rg"};

double get_element_mass(string identity){
	if (atoi(identity.c_str()) != 0) {
		return element_mass[atoi(identity.c_str())-1];
	}
	for (int i = 0; i < 111; i++){
		if (identity == element_name[i] || identity == element_symbol[i]) {
			return element_mass[i];
		} 
	}
}

int factorial(int input){
	int value = input--;
	for (input; input > 0; input--){
		value *= input;
	}
	return value;
}

fstring derive(fstring input){
	
}

fstring antiderive(fstring input){}
